Subject: [VRRP] Re: Vrrp Implementation issue over LinuxIp

From: "Biju Mammen" <[email-masked]>
Date: Wed, 19 Oct 2005 08:59:33 -0700

Hi,

The simple answer (without messing around with kernel code) is to defer
the new interface addition(into linux kernel)till you transition to the
master state for that Virtual IP. When backing out of the master state,
simply revoke the interface (from the kernel) which has been created.

You might also want to create a blackhole route for the interface (the
new interface) so that packets bound for the Virtual IP interface are
dropped.

Thanks
Biju Mammen

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of
[email-masked]
Sent: Wednesday, October 19, 2005 4:55 AM
To: [email-masked]
Subject: vrrp Digest, Vol 16, Issue 1

Send vrrp mailing list submissions to
	[email-masked]

To subscribe or unsubscribe via the World Wide Web, visit
	https://www1.ietf.org/mailman/listinfo/vrrp
or, via email, send a message with subject or body 'help' to
	[email-masked]

You can reach the person managing the list at
	[email-masked]

When replying, please edit your Subject line so it is more specific
than "Re: Contents of vrrp digest..."

Today's Topics:

   1. Vrrp Implementation issue over LinuxIp (venkateshs)
   2. Vrrp Implementation issue over LinuxIp (venkateshs)
   3. Re: Vrrp Implementation issue over LinuxIp (William Stanislaus)
   4. RE: Vrrp Implementation issue over LinuxIp (venkateshs)
   5. Re: Vrrp Implementation issue over LinuxIp (William Stanislaus)
   6. RE: Vrrp Implementation issue over LinuxIp (venkateshs)

----------------------------------------------------------------------

Message: 1
Date: Wed, 19 Oct 2005 15:39:24 +0530
From: "venkateshs" <[email-masked]>
Subject: [VRRP] Vrrp Implementation issue over LinuxIp
To: <[email-masked]>
Message-ID: <[email-masked]>
Content-Type: text/plain; charset="iso-8859-1"

Hi,

   We are planning to run VRRP over a Logical Interface created in Linux
IP.(similar to eth0)

   How we can I prevent that Linux Interface from sending arp reply when
it
is in Backup State?

  Also,How can we to associate various virtual MacAddresses to that
Linux
Interface?

  Please share your valuable suggestions.

Thanks in advance,
Venkatesan S.

************************************************************************
***
This message is proprietary to Future Software Limited (FSL)
and is intended solely for the use of the individual to whom it
is addressed. It may contain  privileged or confidential information
and should not be circulated or used for any purpose other than for
what it is intended.

If you have received this message in error, please notify the
originator immediately. If you are not the intended recipient,
you are notified that you are strictly prohibited from using,
copying, altering, or disclosing the contents of this message.
FSL accepts no responsibility for loss or damage arising from
the use of the information transmitted by this email including
damage from virus.
************************************************************************
***

------------------------------

Message: 2
Date: Wed, 19 Oct 2005 15:50:20 +0530
From: "venkateshs" <[email-masked]>
Subject: [VRRP] Vrrp Implementation issue over LinuxIp
To: <[email-masked]>
Message-ID: <[email-masked]>
Content-Type: text/plain; charset="iso-8859-1"

Hi,

   We are planning to run VRRP over a Logical Interface created in Linux
IP.(similar to eth0)

   How we can prevent that Linux Interface from sending arp reply when
it is
in Backup State?

  Also,How can we associate various virtual MacAddresses to that Linux
Interface?

  Please share your valuable suggestions.

Thanks in advance,
Venkatesan S.

************************************************************************
***
This message is proprietary to Future Software Limited (FSL)
and is intended solely for the use of the individual to whom it
is addressed. It may contain  privileged or confidential information
and should not be circulated or used for any purpose other than for
what it is intended.

If you have received this message in error, please notify the
originator immediately. If you are not the intended recipient,
you are notified that you are strictly prohibited from using,
copying, altering, or disclosing the contents of this message.
FSL accepts no responsibility for loss or damage arising from
the use of the information transmitted by this email including
damage from virus.
************************************************************************
***

------------------------------

Message: 3
Date: Wed, 19 Oct 2005 11:31:31 +0100
From: William Stanislaus <[email-masked]>
Subject: Re: [VRRP] Vrrp Implementation issue over LinuxIp
To: vrrp IETF <[email-masked]>
Message-ID: <[email-masked]>
Content-Type: text/plain;	charset="US-ASCII"

Hi Venkatesh,
When you are requesting arp for a physical interface of any vrrp enabled
interface, we cannot stop sending the arp response, but when you send an
arp
request for the virtual ip address associated to the vrrp, only the
master
sends the arp response.

Can you be more specific what you mean by "various" virtual mac address,
Since for any vrrp virtual ip address, we have unique virtual mac
address
within that network.

-William.

On 19/10/05 11:20, "venkateshs" <[email-masked]> wrote:

> Hi,
> 
>    We are planning to run VRRP over a Logical Interface created in
Linux
> IP.(similar to eth0)
> 
>    How we can prevent that Linux Interface from sending arp reply when
it is
> in Backup State?
> 
>   Also,How can we associate various virtual MacAddresses to that Linux
> Interface?
> 
>   Please share your valuable suggestions.
> 
> Thanks in advance,
> Venkatesan S.
> 
> 
> 
> 
> 
>
************************************************************************
***
> This message is proprietary to Future Software Limited (FSL)
> and is intended solely for the use of the individual to whom it
> is addressed. It may contain  privileged or confidential information
> and should not be circulated or used for any purpose other than for
> what it is intended.
> 
> If you have received this message in error, please notify the
> originator immediately. If you are not the intended recipient,
> you are notified that you are strictly prohibited from using,
> copying, altering, or disclosing the contents of this message.
> FSL accepts no responsibility for loss or damage arising from
> the use of the information transmitted by this email including
> damage from virus.
>
************************************************************************
***
> 
> 
> _______________________________________________
> vrrp mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/vrrp
> 

-- 
Best Regards,
William Stanislaus | Researcher
Electronics Research Group | University of Aberdeen
email: [email-masked] | Mobile +44 7821870521
Office Phone : +44 1224 272813
www.erg.abdn.ac.uk

------------------------------

Message: 4
Date: Wed, 19 Oct 2005 16:29:39 +0530
From: "venkateshs" <[email-masked]>
Subject: RE: [VRRP] Vrrp Implementation issue over LinuxIp
To: "'William Stanislaus'" <[email-masked]>, "'vrrp IETF'"
	<[email-masked]>
Message-ID: <[email-masked]>
Content-Type: text/plain; charset="Windows-1252"

I understand only master  will send the ARP Response?How can I
distinguish
linux device as Master/Slave?

As in the VRRP Mib definitions, We can have multiple VRID for a single
Interface.
If I am having Multiple VRID's over a single Interface like,

  Interface
    |
    |
   VRID1<--------->VRID1
   VRID2<--------->VRID2
   VRID3<--------->VRID3

Assume,if it behaves as a master in case of all VRID's.

We have different Virtual MAC  as 00:00:5e:00:01:01
                                     00:00:5e:00:01:02
                                     00:00:5e:00:01:03 associated with
that
Interface.

Can these mac addresses associated with a Single Linux Interface?

Thanks
Venkatesan S.

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On Behalf Of
William Stanislaus
Sent: Wednesday, 19 October 2005 4:02 PM
To: vrrp IETF
Subject: Re: [VRRP] Vrrp Implementation issue over LinuxIp

Hi Venkatesh,
When you are requesting arp for a physical interface of any vrrp enabled
interface, we cannot stop sending the arp response, but when you send an
arp
request for the virtual ip address associated to the vrrp, only the
master
sends the arp response.

Can you be more specific what you mean by "various" virtual mac address,
Since for any vrrp virtual ip address, we have unique virtual mac
address
within that network.

-William.

On 19/10/05 11:20, "venkateshs" <[email-masked]> wrote:

> Hi,
>
>    We are planning to run VRRP over a Logical Interface created in
Linux
> IP.(similar to eth0)
>
>    How we can prevent that Linux Interface from sending arp reply when
it
is
> in Backup State?
>
>   Also,How can we associate various virtual MacAddresses to that Linux
> Interface?
>
>   Please share your valuable suggestions.
>
> Thanks in advance,
> Venkatesan S.
>
>
>
>
>
>
************************************************************************
***
> This message is proprietary to Future Software Limited (FSL)
> and is intended solely for the use of the individual to whom it
> is addressed. It may contain  privileged or confidential information
> and should not be circulated or used for any purpose other than for
> what it is intended.
>
> If you have received this message in error, please notify the
> originator immediately. If you are not the intended recipient,
> you are notified that you are strictly prohibited from using,
> copying, altering, or disclosing the contents of this message.
> FSL accepts no responsibility for loss or damage arising from
> the use of the information transmitted by this email including
> damage from virus.
>
************************************************************************
***
>
>
> _______________________________________________
> vrrp mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/vrrp
>

--
Best Regards,
William Stanislaus | Researcher
Electronics Research Group | University of Aberdeen
email: [email-masked] | Mobile +44 7821870521
Office Phone : +44 1224 272813
www.erg.abdn.ac.uk

_______________________________________________
vrrp mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/vrrp

************************************************************************
***
This message is proprietary to Future Software Limited (FSL)
and is intended solely for the use of the individual to whom it
is addressed. It may contain  privileged or confidential information
and should not be circulated or used for any purpose other than for
what it is intended.

If you have received this message in error, please notify the
originator immediately. If you are not the intended recipient,
you are notified that you are strictly prohibited from using,
copying, altering, or disclosing the contents of this message.
FSL accepts no responsibility for loss or damage arising from
the use of the information transmitted by this email including
damage from virus.
************************************************************************
***

------------------------------

Message: 5
Date: Wed, 19 Oct 2005 12:20:38 +0100
From: William Stanislaus <[email-masked]>
Subject: Re: [VRRP] Vrrp Implementation issue over LinuxIp
To: <[email-masked]>, vrrp IETF <[email-masked]>
Message-ID: <[email-masked]>
Content-Type: text/plain;	charset="US-ASCII"

You can verify who is master from the VRRP advertisement message.

Normally you have multiple VRID for single interface in a clustering
mode
for load sharing/balancing. When all routers who were master for their
VRID's fail except one router, then that router can act as Master for
all
the VRID's as you have mentioned.

Check RFC 3768 Section 4.2.

-William.

On 19/10/05 11:59, "venkateshs" <[email-masked]> wrote:

> 
> I understand only master  will send the ARP Response?How can I
distinguish
> linux device as Master/Slave?
> 
> As in the VRRP Mib definitions, We can have multiple VRID for a single
> Interface.
> If I am having Multiple VRID's over a single Interface like,
> 
>   Interface
>     |
>     |
>    VRID1<--------->VRID1
>    VRID2<--------->VRID2
>    VRID3<--------->VRID3
> 
> Assume,if it behaves as a master in case of all VRID's.
> 
> We have different Virtual MAC  as 00:00:5e:00:01:01
>                                      00:00:5e:00:01:02
>                                      00:00:5e:00:01:03 associated with
that
> Interface.
> 
> Can these mac addresses associated with a Single Linux Interface?
> 
> Thanks
> Venkatesan S.
> 
> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]On Behalf Of
> William Stanislaus
> Sent: Wednesday, 19 October 2005 4:02 PM
> To: vrrp IETF
> Subject: Re: [VRRP] Vrrp Implementation issue over LinuxIp
> 
> 
> Hi Venkatesh,
> When you are requesting arp for a physical interface of any vrrp
enabled
> interface, we cannot stop sending the arp response, but when you send
an arp
> request for the virtual ip address associated to the vrrp, only the
master
> sends the arp response.
> 
> Can you be more specific what you mean by "various" virtual mac
address,
> Since for any vrrp virtual ip address, we have unique virtual mac
address
> within that network.
> 
> -William.
> 
> 
> On 19/10/05 11:20, "venkateshs" <[email-masked]> wrote:
> 
>> Hi,
>> 
>>    We are planning to run VRRP over a Logical Interface created in
Linux
>> IP.(similar to eth0)
>> 
>>    How we can prevent that Linux Interface from sending arp reply
when it
> is
>> in Backup State?
>> 
>>   Also,How can we associate various virtual MacAddresses to that
Linux
>> Interface?
>> 
>>   Please share your valuable suggestions.
>> 
>> Thanks in advance,
>> Venkatesan S.
>> 
>> 
>> 
>> 
>> 
>> 
>
************************************************************************
***
>> This message is proprietary to Future Software Limited (FSL)
>> and is intended solely for the use of the individual to whom it
>> is addressed. It may contain  privileged or confidential information
>> and should not be circulated or used for any purpose other than for
>> what it is intended.
>> 
>> If you have received this message in error, please notify the
>> originator immediately. If you are not the intended recipient,
>> you are notified that you are strictly prohibited from using,
>> copying, altering, or disclosing the contents of this message.
>> FSL accepts no responsibility for loss or damage arising from
>> the use of the information transmitted by this email including
>> damage from virus.
>> 
>
************************************************************************
***
>> 
>> 
>> _______________________________________________
>> vrrp mailing list
>> [email-masked]
>> https://www1.ietf.org/mailman/listinfo/vrrp
>> 
> 
> --
> Best Regards,
> William Stanislaus | Researcher
> Electronics Research Group | University of Aberdeen
> email: [email-masked] | Mobile +44 7821870521
> Office Phone : +44 1224 272813
> www.erg.abdn.ac.uk
> 
> 
> 
> _______________________________________________
> vrrp mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/vrrp
> 
> 
> 
> 
>
************************************************************************
***
> This message is proprietary to Future Software Limited (FSL)
> and is intended solely for the use of the individual to whom it
> is addressed. It may contain  privileged or confidential information
> and should not be circulated or used for any purpose other than for
> what it is intended.
> 
> If you have received this message in error, please notify the
> originator immediately. If you are not the intended recipient,
> you are notified that you are strictly prohibited from using,
> copying, altering, or disclosing the contents of this message.
> FSL accepts no responsibility for loss or damage arising from
> the use of the information transmitted by this email including
> damage from virus.
>
************************************************************************
***

-- 
Best Regards,
William Stanislaus | Researcher
Electronics Research Group | University of Aberdeen
email: [email-masked] | Mobile +44 7821870521
Office Phone : +44 1224 272813
www.erg.abdn.ac.uk

------------------------------

Message: 6
Date: Wed, 19 Oct 2005 17:29:12 +0530
From: "venkateshs" <[email-masked]>
Subject: RE: [VRRP] Vrrp Implementation issue over LinuxIp
To: "'William Stanislaus'" <[email-masked]>
Cc: [email-masked]
Message-ID: <[email-masked]>
Content-Type: text/plain; charset="Windows-1252"

I want the Linux kernel to Respond for ARP Requests.

Kernel should send ARP Response with VRRP MAC in case of Master State.
If it is in backup state,ARP Requests should be dropped by kernel
itself.

How can I make Linux Interface to understand different VMAC and respond
with
them?

Thanks
Venkatesan S.

-----Original Message-----
From: William Stanislaus [mailto:[email-masked]]
Sent: Wednesday, 19 October 2005 4:51 PM
To: [email-masked]; vrrp IETF
Subject: Re: [VRRP] Vrrp Implementation issue over LinuxIp

You can verify who is master from the VRRP advertisement message.

Normally you have multiple VRID for single interface in a clustering
mode
for load sharing/balancing. When all routers who were master for their
VRID's fail except one router, then that router can act as Master for
all
the VRID's as you have mentioned.

Check RFC 3768 Section 4.2.

-William.

On 19/10/05 11:59, "venkateshs" <[email-masked]> wrote:

>
> I understand only master  will send the ARP Response?How can I
distinguish
> linux device as Master/Slave?
>
> As in the VRRP Mib definitions, We can have multiple VRID for a single
> Interface.
> If I am having Multiple VRID's over a single Interface like,
>
>   Interface
>     |
>     |
>    VRID1<--------->VRID1
>    VRID2<--------->VRID2
>    VRID3<--------->VRID3
>
> Assume,if it behaves as a master in case of all VRID's.
>
> We have different Virtual MAC  as 00:00:5e:00:01:01
>                                      00:00:5e:00:01:02
>                                      00:00:5e:00:01:03 associated with
that
> Interface.
>
> Can these mac addresses associated with a Single Linux Interface?
>
> Thanks
> Venkatesan S.
>
> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]On Behalf Of
> William Stanislaus
> Sent: Wednesday, 19 October 2005 4:02 PM
> To: vrrp IETF
> Subject: Re: [VRRP] Vrrp Implementation issue over LinuxIp
>
>
> Hi Venkatesh,
> When you are requesting arp for a physical interface of any vrrp
enabled
> interface, we cannot stop sending the arp response, but when you send
an
arp
> request for the virtual ip address associated to the vrrp, only the
master
> sends the arp response.
>
> Can you be more specific what you mean by "various" virtual mac
address,
> Since for any vrrp virtual ip address, we have unique virtual mac
address
> within that network.
>
> -William.
>
>
> On 19/10/05 11:20, "venkateshs" <[email-masked]> wrote:
>
>> Hi,
>>
>>    We are planning to run VRRP over a Logical Interface created in
Linux
>> IP.(similar to eth0)
>>
>>    How we can prevent that Linux Interface from sending arp reply
when it
> is
>> in Backup State?
>>
>>   Also,How can we associate various virtual MacAddresses to that
Linux
>> Interface?
>>
>>   Please share your valuable suggestions.
>>
>> Thanks in advance,
>> Venkatesan S.
>>
>>
>>
>>
>>
>>
>
************************************************************************
***
>> This message is proprietary to Future Software Limited (FSL)
>> and is intended solely for the use of the individual to whom it
>> is addressed. It may contain  privileged or confidential information
>> and should not be circulated or used for any purpose other than for
>> what it is intended.
>>
>> If you have received this message in error, please notify the
>> originator immediately. If you are not the intended recipient,
>> you are notified that you are strictly prohibited from using,
>> copying, altering, or disclosing the contents of this message.
>> FSL accepts no responsibility for loss or damage arising from
>> the use of the information transmitted by this email including
>> damage from virus.
>>
>
************************************************************************
***
>>
>>
>> _______________________________________________
>> vrrp mailing list
>> [email-masked]
>> https://www1.ietf.org/mailman/listinfo/vrrp
>>
>
> --
> Best Regards,
> William Stanislaus | Researcher
> Electronics Research Group | University of Aberdeen
> email: [email-masked] | Mobile +44 7821870521
> Office Phone : +44 1224 272813
> www.erg.abdn.ac.uk
>
>
>
> _______________________________________________
> vrrp mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/vrrp
>
>
>
>
>
************************************************************************
***
> This message is proprietary to Future Software Limited (FSL)
> and is intended solely for the use of the individual to whom it
> is addressed. It may contain  privileged or confidential information
> and should not be circulated or used for any purpose other than for
> what it is intended.
>
> If you have received this message in error, please notify the
> originator immediately. If you are not the intended recipient,
> you are notified that you are strictly prohibited from using,
> copying, altering, or disclosing the contents of this message.
> FSL accepts no responsibility for loss or damage arising from
> the use of the information transmitted by this email including
> damage from virus.
>
************************************************************************
***

--
Best Regards,
William Stanislaus | Researcher
Electronics Research Group | University of Aberdeen
email: [email-masked] | Mobile +44 7821870521
Office Phone : +44 1224 272813
www.erg.abdn.ac.uk

************************************************************************
***
This message is proprietary to Future Software Limited (FSL)
and is intended solely for the use of the individual to whom it
is addressed. It may contain  privileged or confidential information
and should not be circulated or used for any purpose other than for
what it is intended.

If you have received this message in error, please notify the
originator immediately. If you are not the intended recipient,
you are notified that you are strictly prohibited from using,
copying, altering, or disclosing the contents of this message.
FSL accepts no responsibility for loss or damage arising from
the use of the information transmitted by this email including
damage from virus.
************************************************************************
***

------------------------------

_______________________________________________
vrrp mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/vrrp

End of vrrp Digest, Vol 16, Issue 1
***********************************

_______________________________________________
vrrp mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/vrrp

---

From: "MUNEER CH" <[email-masked]>
Date: 31 Oct 2005 06:20:29 -0000

Hi,
   I was trying to implement VRRP on linux IP. I have applied a kernel patch to alter the real mac address with the virtual mac address when a host requests for arp resolve for VRIP.
But the problem I encountered is, a data packet with this faked mac is getting dropped by kernel. Is there any way to make a kernel to accept a packet with virtual mac?

Thanks in advance
Regards
Muneer CH

On Wed, 19 Oct 2005 Don Provan wrote :
>Hope the list doesn't mind this Linux specific conversation....
>
>I'm not sure what this means. I run VRRP over an ethernet
>interface. Is what you're doing significantly different?
>
> >    How we can I prevent that Linux Interface from sending arp
> > reply when it is in Backup State?
>
>Well, I think you're asking the wrong question. The real
>question is how to you make the interface send an ARP reply
>when it's supposed to. I always find it fascinating that
>there's really no good reason for the non-owner system to
>know the VR IP address at all except for ARP, so you're
>best off if you can avoid attaching it to an interface
>to begin with instead of attaching it and trying to
>suppress the results.
>
>I manipulate the ARP table directly, although in
>the 2.4 kernel I had to extend to kernel's ARP code to
>allow setting an ARP entry with a specific MAC address.
>(I don't know if 2.6 supports that out of the box.)
>
> >   Also,How can we to associate various virtual MacAddresses
> > to that Linux Interface?
>
>You just add them as if they were multicast MAC addresses
>you want your hardware to accept for delivery
>Remember, the kernel should always use the natural MAC
>address for all packets it sends. Only the VRRP packets
>that your VRRP app generates should have the VR MAC
>address as the source.
>
>-don